//= require <dSS/ZoneView>
Ext.namespace('dSS');

dSS.ZonePanel = Ext.extend(Ext.Panel, {
    initComponent: function() {
        Ext.apply(this, {
            title: dSS._("Rooms"),
            layout: 'border',
            items: [
            {
                xtype: 'dsszoneview',
                ref: 'zoneView',
                region: 'center'
            }]
        });

        this.tbar = this.buildTopToolbar();

        this.zoneSortMode = 0;

        dSS.ZonePanel.superclass.initComponent.apply(this, arguments);
    },

    buildTopToolbar: function() {
        return [
            {
                iconCls: 'blink',
                handler: this.blinkZone,
                tooltip: dSS._("Blink all devices in room"),
                scope: this
            },
            {
                iconCls: 'addZoneIcon',
                handler: this.createNewZone,
                tooltip: dSS._("Create new room"),
                scope: this
            },
            {
                iconCls: 'renameZoneIcon',
                handler: this.renameZone,
                tooltip: dSS._("Rename selected room"),
                scope: this
            },
            '->',
            {
                iconCls: 'removeZoneIcon',
                handler: this.removeZone,
                tooltip: dSS._("Remove selected room"),
                scope: this
            }
        ];
    },
    removeZone: function() {
        this.zoneView.removeZone();
    },
    blinkZone: function() {
        this.zoneView.blinkZone();
    },
    renameZone: function() {
        this.zoneView.renameZone();
    },
    createNewZone: function() {
        this.zoneView.createNewZone();
    }
    /*
    sortZonesCycle: function() {
        var zstore = dSS.data.Loader.getZoneStore();
        switch (this.zoneSortMode) {
        case 0:
            zstore.sort('id', 'ASC');
            this.zoneSortMode++;
            break;
        case 1:
            zstore.sort('id', 'DESC');
            this.zoneSortMode++;
            break;
        case 2:
            zstore.sort('name', 'ASC');
            this.zoneSortMode++;
            break;
        case 3:
            zstore.sort('name', 'DESC');
            this.zoneSortMode = 0;
            break;
        default:
            this.zoneSortMode = 0;
            break;
        }
    }
    */
});

Ext.reg('dsszonepanel', dSS.ZonePanel);

